﻿//using System.Collections.Generic;
//using System.Collections.ObjectModel;
//using ThinkGeo.MapSuite.Core;
//using ThinkGeo.MapSuite.Styles;

//namespace SampleWebApp
//{
//    class ClusterPointStyle : PointStyle
//    {
//        private int cellSize = 100;
//        private TextStyle textSytle = new TextStyle();

//        // These are all of the constructors from the original point style  
//        public ClusterPointStyle()
//            : base()
//        { }

//        public ClusterPointStyle(GeoImage image)
//            : base(image)
//        { }

//        public ClusterPointStyle(GeoFont characterFont, int characterIndex, GeoSolidBrush characterSolidBrush)
//            : base(characterFont, characterIndex, characterSolidBrush)
//        { }

//        public ClusterPointStyle(PointSymbolType symbolType, GeoSolidBrush symbolSolidBrush, int symbolSize)
//            : base(symbolType, symbolSolidBrush, symbolSize)
//        { }

//        public ClusterPointStyle(PointSymbolType symbolType, GeoSolidBrush symbolSolidBrush, GeoPen symbolPen, int symbolSize)
//            : base(symbolType, symbolSolidBrush, symbolPen, symbolSize)
//        { }

//        // The TextStyle will be the label on the cluster.  
//        public TextStyle TextStyle
//        {
//            get { return textSytle; }
//            set { textSytle = value; }
//        }

//        // This is in pixels and determines how the screen will be divided.  The smaller the slower it runs  
//        public int CellSize
//        {
//            get { return cellSize; }
//            set { cellSize = value; }
//        }

//        // Here in the DrawCore we cluster the features  
//        protected override void DrawCore(IEnumerable<Feature> features, GeoCanvas canvas, Collection<SimpleCandidate> labelsInThisLayer, Collection<SimpleCandidate> labelsInAllLayers)
//        {
//            //  We get the scale to determine the grid.  This scale property should really be on the Canvas!  
//            double scale = ExtentHelper.GetScale(canvas.CurrentWorldExtent, canvas.Width, canvas.MapUnit);

//            // Setup our grid for clustering the points.  This is where we specify our cell size in pixels  
//            MapSuiteTileMatrix mapSuiteTileMatrix = new MapSuiteTileMatrix(scale, cellSize, cellSize, canvas.MapUnit);

//            // Pass in the current extent to get our grid cells.  All points in these cells will be consolidated  
//            IEnumerable<TileMatrixCell> tileMatricCells = mapSuiteTileMatrix.GetContainedCells(canvas.CurrentWorldExtent);

//            // Create an unused features list, as we add them to clusters we will remove them from here  
//            // This is just for speed so we don't re-test lots of already associated features  
//            Dictionary<string, string> unusedFeatures = new Dictionary<string, string>();
//            foreach (Feature feature in features)
//            {
//                unusedFeatures.Add(feature.Id, feature.Id);
//            }

//            // Loop through each cell and find the features that fit inside of it  
//            foreach (TileMatrixCell cell in tileMatricCells)
//            {
//                int featureCount = 0;
//                MultipointShape multiPointShape = new MultipointShape();
//                foreach (Feature feature in features)
//                {
//                    // Make sure the feature has not been used in another cluster  
//                    if (unusedFeatures.ContainsKey(feature.Id))
//                    {
//                        // Check if the cell contains the feature  
//                        if (cell.BoundingBox.Contains(feature.GetBoundingBox()))
//                        {
//                            featureCount++;
//                            unusedFeatures.Remove(feature.Id);
//                            multiPointShape.Points.Add(feature.GetBoundingBox().GetCenterPoint());
//                        }
//                    }
//                }
//                if (featureCount > 0)
//                {
//                    // Add the feature count to the new feature we created.  The feature will be placed  
//                    // at the center of gravity of all the clustered features of the cell we created.  
//                    Dictionary<string, string> featureValues = new Dictionary<string, string>();
//                    featureValues.Add("FeatureCount", featureCount.ToString());

//                    //Draw the point shape  
//                    base.DrawCore(new Feature[] { new Feature(multiPointShape.GetCenterPoint(), featureValues) }, canvas, labelsInThisLayer, labelsInAllLayers);

//                    // Draw the text style to show how many feaures are consolidated in the cluster  
//                    textSytle.Draw(new Feature[] { new Feature(multiPointShape.GetCenterPoint(), featureValues) }, canvas, labelsInThisLayer, labelsInAllLayers);
//                }
//            }
//        }

//    }
//}